#SingleInstance, Force


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;How to use
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;You execute (doubleClick) this AutoHotkey code
;It finds ".sdlxliff" you want to convert
;It converts it
;Open converted ".sdlxliff" at Trados Studio
;Now, You are Happy
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;It handels original ".sdlxliff" directly and does not make any kind of backups
;So
;You have to be very careful about it.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



SoundBeep, 2222, 44
SoundBeep, 2222, 44
FileSelectFile, myFilePath,, % A_ScriptDir, select SDL Trados Studio file, SDL sdlxliff (*.sdlxliff)  
If ErrorLevel OR Not RegExReplace(myFilePath, ".*\.") ~= "sdlxliff"
{	
	SoundBeep, 333, 666
	Return
}
SoundBeep, 1111, 44
SoundBeep, 1111, 44
FileEncoding, UTF-8							
FileRead, myFileContents, % myFilePath
Global xd
Global externalCommentID
xd := ComObjCreate("MSXML2.DOMDocument.6.0")
xd.Async := False
xd.PreserveWhitespace := True   
xd.setProperty("SelectionNamespaces", "xmlns=""urn:oasis:names:tc:xliff:document:1.2"" xmlns:sdl=""http://sdl.com/FileTypes/SdlXliff/1.0""")
xd.LoadXML(myFileContents)
If xd.parseError.errorCode
{
    MsgBox % xd.parseError.errorCode "`n" xd.parseError.reason
    Return
}
TUfiltering(xd)
xd.PreserveWhitespace := True   													
xd.save(myFilePath)		
removeUnNecessaryItem(myFilePath)
SoundBeep, 2222, 44
SoundBeep, 1111, 44
SoundBeep, 2222, 44
SoundBeep, 1111, 44
SoundBeep, 2222, 44
SoundBeep, 1111, 44
Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TUfiltering(e)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{		
	If(e.nodeName = "trans-unit")
		TUvisitor(e)
	Else
		For x In e.childNodes
			TUfiltering(x)				
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TUvisitor(e)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	If(e.childNodes.Length < 4)    	
		Return
	externalCommentID := ""									
	For x In e.childNodes
		If(x.nodeName = "sdl:cmt")		  					   
			externalCommentID := x.getAttribute("id")   				
	For x In e.childNodes
		If(x.nodeName = "target")	
			TargetVisitor(x)   	
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TargetVisitor(e)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	For x In e.childNodes
		If(x.nodeName = "mrk" && x.getAttribute("mtype") = "seg")				
		{
		    If(externalCommentID = "")
				Continue
			commentElement := xd.createElement("mrk")							
			commentElement.setAttribute("mtype", "x-sdl-comment")			
			commentElement.setAttribute("sdl:cid", externalCommentID)		
			If(x.childNodes.Length = 0)
				x.appendChild(commentElement)
			Else
				x.insertBefore(commentElement, x.firstChild)				
		}
		Else
			TargetVisitor(x)	
}
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
removeUnNecessaryItem(filePath)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
{
	FileEncoding, UTF-8							
	FileRead, myContents, % filePath												
	myContents := RegExReplace(myContents, " xmlns=""""")																																			
	FileDelete, % filePath
	FileAppend, % myContents, % filePath
}
